USACO Telephone Lines

洛谷 P1948 [USACO08JAN]电话线Telephone Lines

https://www.luogu.org/problem/P1948

JDOJ 2556: USACO 2008 Jan Silver 3.Telephone Lines

https://neooj.com/oldoj/problem.php?id=2556

题目描述

Farmer John wants to set up a telephone line at his farm. Unfortunately, the phone company is uncooperative, so he needs to pay for some of the cables required to connect his farm to the phone system.

There are N (1 ≤ N ≤ 1,000) forlorn telephone poles conveniently numbered 1..N that are scattered around Farmer John's property; no cables connect any them. A total of P (1 ≤ P ≤ 10,000) pairs of poles can be connected by a cable; the rest are too far apart.

The i-th cable can connect the two distinct poles Ai and Bi, with length Li (1 ≤ Li ≤ 1,000,000) units if used. The input data set never names any {Ai, Bi} pair more than once. Pole 1 is already connected to the phone system, and pole N is at the farm. Poles 1 and N need to be connected by a path of cables; the rest of the poles might be used or might not be used.

As it turns out, the phone company is willing to provide Farmer John with K (0 ≤ K < N) lengths of cable for free. Beyond that he will have to pay a price equal to the length of the longest remaining cable he requires (each pair of poles is connected with a separate cable), or 0 if he does not need any additional cables.

Determine the minimum amount that Farmer John must pay.

多年以后,笨笨长大了,成为了电话线布置师。由于地震使得某市的电话线全部损坏,笨笨是负责接到震中市的负责人。该市周围分布着N(1<=N<=1000)根据1……n顺序编号的废弃的电话线杆,任意两根线杆之间没有电话线连接,一共有p(1<=p<=10000)对电话杆可以拉电话线。其他的由于地震使得无法连接。

第i对电线杆的两个端点分别是ai,bi,它们的距离为li(1<=li<=1000000)。数据中每对(ai,bi)只出现一次。编号为1的电话杆已经接入了全国的电话网络,整个市的电话线全都连到了编号N的电话线杆上。也就是说,笨笨的任务仅仅是找一条将1号和N号电线杆连起来的路径,其余的电话杆并不一定要连入电话网络。

电信公司决定支援灾区免费为此市连接k对由笨笨指定的电话线杆,对于此外的那些电话线,需要为它们付费,总费用决定于其中最长的电话线的长度(每根电话线仅连接一对电话线杆)。如果需要连接的电话线杆不超过k对,那么支出为0.

请你计算一下,将电话线引导震中市最少需要在电话线上花多少钱?

输入格式

输入文件的第一行包含三个数字n,p,k;

第二行到第p+1行,每行分别都为三个整数ai,bi,li。

输出格式

一个整数,表示该项工程的最小支出,如果不可能完成则输出-1.

输入输出样例

输入 #1
5 7 1
1 2 5
3 1 4
2 4 8
3 2 3
5 2 9
3 4 7
4 5 6
输出 #1
4


SPFA+二分答案

因为它给你k次免费的机会,所以根据贪心思想,我们应该尽可能地把路线上前k长的路交给电信来修,也就是说我们要求1-n的路径的第k+1长的边的最小值。
我们二分答案就是第k+1条边的最小值。
边界很好设置。
现在就是判断了。
我们可以考虑这样一个重新建图的思路(说是重新建图,其实就是把边权重新更改了一个定义而已。),因为我们二分的是第k+1的边权最小值,那么针对我们二分出来的每一个mid,我们可以跑所有的边,如果这个边权小于mid,说明它是免费的,如果大于的话,说明需要使用一次免费的资格,所以边权重置成1.
然后我们在新的边权图上跑最短路,求出f[n],这时的f[n]就表示从1到n需要几次免费的资格,如果小于等于k,符合题意,范围左缩,反之亦然。

这就是正解了。

代码:
#include<cstdio>
#include<queue>
#include<algorithm>
#include<cstring>
using namespace std;
int n,p,k,ans=-1;
int tot,to[20001],nxt[20001],val[20001],head[1001],s[20001];
int f[1001],v[1001];
void add(int x,int y,int z)
{
    to[++tot]=y;
    nxt[tot]=head[x];
    val[tot]=z;
    head[x]=tot;
}
void spfa()
{
    memset(f,0x3f,sizeof(f));
    memset(v,0,sizeof(v));
    queue<int> q;
    f[1]=0;q.push(1);v[1]=1;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        v[x]=0;
        for(int i=head[x];i;i=nxt[i])
        {
            int y=to[i];
            if(f[y]>f[x]+s[i])
            {
                f[y]=f[x]+s[i];
                if(v[y]==0)
                {
                    q.push(y);
                    v[y]=1;
                }
            }
        }
    }
}
bool check(int x)
{
    for(int i=1;i<=tot;i++)
    {
        if(val[i]<=x)
            s[i]=0;
        else
            s[i]=1;
    }
    spfa();
    if(f[n]<=k)
        return 1;
    else
        return 0;
}
int main()
{
    scanf("%d%d%d",&n,&p,&k);
    for(int i=1;i<=p;i++)
    {
        int x,y,z;
        scanf("%d%d%d",&x,&y,&z);
        add(x,y,z);
        add(y,x,z);
    }
    int l=0;
    int r=1000000;
    while(l<=r)
    {
        int mid=(l+r)>>1;
        if(check(mid))
            ans=mid,r=mid-1;
        else
            l=mid+1;
    }
    printf("%d",ans);
    return 0;
}

猜你喜欢

转载自www.cnblogs.com/fusiwei/p/11254282.html